// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysockemailtransport.h 91 2008-01-21 14:38:55Z wglas $
**
** Copyright (C) 2005 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** A basic email client implementation for transporting arbitrary documents.
** 
*****************************************************************************/

#ifndef FANCYSOCK_EMAIL_TRANSPORT_H
#define FANCYSOCK_EMAIL_TRANSPORT_H

#include <fancysocktransport.h>

namespace Fancy {
  namespace Sock {
    class Address;

    class FANCYSOCK_API EmailClientTransport : public Transport
    {
    public:
      EmailClientTransport();
    
      ~EmailClientTransport();
    
      void setHelo (const std::string &h);
      void setSender (const std::string &s);
      void setAddressee (const std::string &addr);
      void setRelay (const std::string &addr);
      void setTimeout(int msec);

      const std::string &getSender() const;
      const std::string &getAddressee() const;
      const std::string &getHelo() const;
      int                getTimeout() const;

      void openWriteDoc(const std::string &mimetype);
      std::string openReadDoc();

      int write (const char *buf, int count);
      int read (char *buf, int count);

      void closeWriteDoc();

    private:
      EmailClientTransport (const EmailClientTransport &);
      EmailClientTransport &operator=(const EmailClientTransport &);

      int timeout;
      std::string sender;
      std::string addressee;
      std::string domain;
      std::string helo;
      Address *relay;
    };
  }
}

#endif // ! FANCYSOCK_EMAIL_TRANSPORT_H
