// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysocklog.h 89 2007-12-18 20:28:22Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Global logging stuff.
** 
*****************************************************************************/

#ifndef FANCYSOCK_LOG_H
#define FANCYSOCK_LOG_H

#include <fancylog.h>
#include <fancysock.h>

  // facility masks.
#define  FANCYSOCK_LOG_BASE      (1<<0)
#define  FANCYSOCK_LOG_TRANSPORT (1<<1)
#define  FANCYSOCK_LOG_LOOP      (1<<2)
#define  FANCYSOCK_LOG_SERVER    (1<<3)

namespace Fancy {
  namespace Sock {

    extern FANCYSOCK_API fancylog_service *log_service;

    // parse for logging cmdline args and filter out recognized options.
    FANCYSOCK_API void fancylog_parse_arg (int *argc, char **argv);

    inline void vfancylog (int facility,
                           int priority, const char *fmt, va_list ap)
      {
        va_list aq;
        va_copy(aq,ap);
        ::vfancylog(log_service,facility,priority,fmt,aq);
        va_end(aq);
      }

#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));
    
#endif

    inline void fancylog (int facility,
                          int priority, const char *fmt, ...)
      {
        va_list ap;
        va_start(ap, fmt);
        vfancylog(facility,priority,fmt,ap);
        va_end(ap);
      }
  }
}

#endif // ! FANCYSOCK_LOG_H
