// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysocktransstream.h 89 2007-12-18 20:28:22Z wglas $
**
** Copyright (C) 2005 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** stream classes, which encapsulate writing/reading a document from/to a
** transport.
** 
*****************************************************************************/

#ifndef FANCYSOCK_TRANS_STREAM_H
#define FANCYSOCK_TRANS_STREAM_H

#include <iostream>
#include <fancysock.h>

namespace Fancy {
  namespace Sock {

    class Transport;

    class FANCYSOCK_API itransstreambuf : public std::streambuf
    {
    public:
      itransstreambuf(Transport *t, std::string &mimetype);
      ~itransstreambuf();

    protected:
      int_type underflow (int c);

    private:
      int fill_buffer();

      Transport *transport;
    };

    class FANCYSOCK_API itransstream : public std::istream
    {
      itransstreambuf itsbuf;
    public:
      itransstream(Transport *t, std::string &mimetype);
      ~itransstream();
    };

    class FANCYSOCK_API otransstreambuf : public std::streambuf
    {
    public:
      otransstreambuf(Transport *t, const std::string &mimetype);
      ~otransstreambuf();

    protected:
      int_type overflow (int_type c);
      int sync();

    private:
      int put_buffer();

      Transport *transport;
    };

    class FANCYSOCK_API otransstream : public std::ostream
    {
      otransstreambuf otsbuf;
    public:
      otransstream(Transport *t, const std::string &mimetype);
      ~otransstream();
    };

  }
}

#endif
